/* Usage: java fridgemadness_test <num_engineers> <num_drinks> <N> <seed> <output_file>
 * num_engineers is the total number of engineers.  It must be even.
 * num_drinks is the number of drinks, no less than 1.
 * N is the number of drinks on each list, no less than 1 and no greater than num_drinks.
 * seed is a 64-bit integer used to seed the random number generator.
 */
public class fridgemadness_test {
  public static void main(String[] args) {
    int num_engineers = Integer.parseInt(args[0]);
    int num_drinks = Integer.parseInt(args[1]);
    int N = Integer.parseInt(args[2]);
    if (num_engineers < 0 || num_engineers % 2 != 0 || num_drinks < 1 || N < 1 || N > num_drinks) {
      System.exit(1);
    }
    long seed = Long.parseLong(args[3]);
    java.util.Random r = new java.util.Random(seed);
    Spacer sp = new Spacer(args[4]);
    sp.print(num_engineers);
    sp.print(" ");
    sp.print(num_drinks);
    sp.println();
    for (int j = 0; j < num_drinks; j++) {
      sp.print(j);
      sp.printSpace();
      sp.print("Drink");
      sp.printSpace();
      sp.print(j);
      sp.println();
    }
    int[] pref = new int[num_drinks];
    for (int j = 0; j < num_drinks; j++) pref[j] = j;
    for (int i = 0; i < num_engineers; i++) {
      sp.print(i);
      sp.printSpace();
      for (int k = 0; k < N; k++) {
        if (k > 0) sp.print(",");
        int l = k + r.nextInt(num_drinks - k);
        int t = pref[k];
        pref[k] = pref[l];
        pref[l] = t;
        sp.print(pref[k]);
      }
      sp.println();
    }
    sp.close((int)seed % 3);
  }
}
